﻿using System;
using System.Linq;
using System.Windows.Forms;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace LazyBoxer.UI
{
    public partial class Wizard : Form
    {
        public Wizard()
        {
            InitializeComponent();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void rbLeader_CheckedChanged(object sender, EventArgs e)
        {
            ucDropdown1.Visible = false;
            nudDistance.Visible = false;
        }

        private void rbSlave_CheckedChanged(object sender, EventArgs e)
        {
            ucDropdown1.Visible = true;
            nudDistance.Visible = true;
        }

        private void Wizard_Load(object sender, EventArgs e)
        {
            PopulateDynamicLeader();
        }

        private void PopulateDynamicLeader()
        {
            // populate our dynamic leader dropdown list
            ucDropdown1.cbDropdown.Items.Clear();
            ucDropdown1.cbDropdown.Items.Add("[Not in this list]");
            ucDropdown1.cbDropdown.Items.Add("[Automatically find someone]");

            try
            {
                IOrderedEnumerable<WoWPlayer> units = ObjectManager.GetObjectsOfTypeFast<WoWPlayer>().Where(u => u.IsAlive && u.IsFriendly && u.Distance < 100 && u.IsPlayer).OrderBy(u => u.Name);
                foreach (WoWPlayer unit in units.Where(unit => unit.Guid != StyxWoW.Me.Guid))
                {
                    ucDropdown1.cbDropdown.Items.Add(unit.Name);
                }

                ucDropdown1.cbDropdown.SelectedItem = Setting.Instance.FollowLeader;
                if (ucDropdown1.cbDropdown.SelectedItem == null || (string)ucDropdown1.cbDropdown.SelectedItem == "")
                {
                    ucDropdown1.Value = "[Automatically find someone]";
                }
            }
            catch (Exception e) { }

        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void rbTargetingManual_CheckedChanged(object sender, EventArgs e)
        {
            ddTargeting.Visible = false;
            nudTargetDistance.Visible = false;

        }

        private void rbTargetingAssist_CheckedChanged(object sender, EventArgs e)
        {
            ddTargeting.Visible = false;
            nudTargetDistance.Visible = false;
        }

        private void rbTargetingAutomatic_CheckedChanged(object sender, EventArgs e)
        {
            ddTargeting.Visible = true;
            nudTargetDistance.Visible = true;
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab("tabCommon");
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab("tabLooting");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab("tabAcceptStuff");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab("tabQuests");
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab("tabDone");
        }

        private void rbNoQuests_CheckedChanged(object sender, EventArgs e)
        {
            ddQuestObjectPickup.Visible = false;
            ddQuestReward.Visible = false;
        }

        private void rbQuests_CheckedChanged(object sender, EventArgs e)
        {
            ddQuestObjectPickup.Visible = true;
            ddQuestReward.Visible = true;
        }

        private void rbLootAll_CheckedChanged(object sender, EventArgs e)
        {
            nudHarvestRange.Visible = true;
        }

        private void rbLootOnlyLoot_CheckedChanged(object sender, EventArgs e)
        {
            nudHarvestRange.Visible = false;
        }

        private void rbNoHarvesting_CheckedChanged(object sender, EventArgs e)
        {
            nudHarvestRange.Visible = false;
        }

        private void button11_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnSAVE_Click(object sender, EventArgs e)
        {
            // SAVE
            MessageBox.Show("SORRY THIS IS NOT YET IMPLEMENTED YET. ITS ON THE TO DO LIST");
        }

        private void button10_Click(object sender, EventArgs e)
        {
            tabControl1.SelectTab(rbLeader.Checked ? "tabDone" : "tabChatCommands");
        }

        private void rbQuests_CheckedChanged_1(object sender, EventArgs e)
        {
            ddQuestObjectPickup.Visible = true;
            ddQuestReward.Visible = true;
        }

        private void rbNoQuests_CheckedChanged_1(object sender, EventArgs e)
        {
            ddQuestObjectPickup.Visible = false;
            ddQuestReward.Visible = false;
        }
    }
}
